# TODO: find/test all errors that abort a job
ERROR_CODES_JOB_FAILED = (
  83902466, 83902467, 83902468, 83902469, 83902470, 83902471, 83902472, 83902473,  83902474, 83902475, 117456897,
  83902476, 83902477, 83902478, 83902484, 83902485, 83902486, 83902509, 83902510, 83902511, 83902519, 83902520,
  83902522, 83918867, 83935248, 83968052, 50348032, 50348033, 50348034, 50348045, 50364424, 50364430, 50364432
)

# Errors  client abort jobs manualy
ERROR_CODES_TO_ABORT_JOB = (50364433,)

LOCAL_CANCEL_CODE = 50348044

ALL_ERRORS = {
    5324857: 'Device login has expired, please try to bind again.',
    50348032: 'Printing stopped because homing Z axis failed.',
    50348033: 'The printer timed out waiting for the nozzle to cool down '
              'before homing.',
    50348034: 'Printing Stopped because Auto Bed Leveling failed.',
    50348037: 'The nozzle fan speed is abnormal.',
    50348038: 'The nozzle is clogged.',
    50348040: 'The AMS failed to change filament.',
    50348041: 'Homing XY axis failed.',
    50348042: 'Mechanical resonance frequency identification failed.',
    50348043: 'Internal communication exception.',
    50348044: 'Printing was cancelled.',
    50348045: 'Resume failed after power loss.',
    50348046: 'The motor self-check failed.',
    50364416: 'Printing was paused for unknown reason. You can tap "Resume" to '
              'resume the print job.',
    50364417: 'Printing was paused by the user. You can tap "Resume" to resume '
              'the print job.',
    50364418: 'First layer defects were detected by the Micro Lidar. Please '
              'check the quality of the printed model before continuing your '
              'print.',
    50364419: 'Spaghetti defects were detected by the AI Print Monitoring. '
              'Please check the quality of the printed model before continuing '
              'your print.',
    50364420: 'Filament ran out. Please load new filament.',
    50364421: 'Toolhead front cover fell off. Please remount the front cover '
              'and check to make sure your print is going okay.',
    50364422: 'The build plate marker was not detected. Please confirm the '
              'build plate is correctly positioned on the heatbed with all '
              'four corners aligned, and the maker is clear.',
    50364423: 'There was an unfinished print job when the printer lost power. '
              'If the model is still adhered to the build plate, you can try '
              'resuming the print job.',
    50364424: 'Printing Stopped because nozzle temperature problem.',
    50364425: 'Heatbed temperature malfunction.',
    50364426: 'A Filament pile-up was detected by the AI Print Monitoring. '
              'Please clean the filament from the waste chute.',
    50364427: 'The cutter is stuck. Please make sure the cutter handle is out.',
    50364428: 'Skipping step detected, auto-recover complete; please resume '
              'print and check if there are any layer shift problems.',
    50364429: 'Some objects have fallen down, or the extruder is not extruding '
              'normally. If the defects are acceptable, click "Resume" button '
              'to resume the print job.',
    50364430: 'The print file is not available. Please check to see if the '
              'storage media has been removed.',
    50364431: 'The door seems to be open, so printing was paused.',
    50364432: 'Printing stopped because the hotend fan speed is abnormal.',
    50364433: 'Detected build plate is not the same as the Gcode file. Please '
              'adjust slicer settings or use the correct plate. ',
    50364435: 'Printing was paused by the user. You can select "Resume" to '
              'continue printing.',
    50364436: 'The nozzle is covered with filaments, or the build plate is '
              'installed incorrectly. Please cancel this printing and clean '
              'the nozzle or adjust the build plate according to the actual '
              'status, or tap "Resume" button to resume the print job.',
    50364437: 'The filament has run out, please load new filament in the '
              '"filament" page.',
    50364438: 'The nozzle is clogged up with filaments. Please cancel this '
              'printing and clean the nozzle according to the actual status, '
              'or tap "Resume" button to resume the print job.',
    50364439: 'Foreign objects detected on hotbed, Please check and clean the '
              'hotbed, Then tap "Resume" button to resume the print job.',
    50364440: 'Chamber temperature malfunction.',
    50364441: 'No build plate is placed.',
    83902465: 'Failed to connect to Bambu Cloud. Please check your network '
              'connection.',
    83902466: 'Unsupported print file path or name. Please resend the printing '
              'job.',
    83902467: 'Printing stopped because the printer was unable to parse the '
              'file. Please resend your print job.',
    83902468: "The printer can't receive new print jobs while printing. Resend "
              'after the current print finishes.',
    83902469: 'Print jobs are not allowed to be sent while updating firmware.',
    83902470: 'There is not enough free storage space for the print job. '
              'Restoring to factory settings can release available space.',
    83902471: 'Print jobs are not allowed to be sent while force updating or '
              'when repair updating is required.',
    83902472: 'Starting printing failed. please power cycle the printer and '
              'resend the print job.',
    83902473: 'Print jobs are not allowed to be sent while updating logs.',
    83902474: 'The file name is not supported. Please rename and restart the '
              'printing job.',
    83902475: 'There was a problem downloading a file. Please check you '
              'network connection and resend the printing job.',
    83902476: 'Please insert a MicroSD card and restart the printing job.',
    83902477: 'Please run a self-test and restart the printing job.',
    83902478: 'Printing was cancelled.',
    83902484: 'Slicing for the print job failed. Please check your settings '
              'and restart the print job.',
    83902485: 'There is not enough free storage space for the print job. '
              'Please format or clean MicroSD card to release available space.',
    83902486: 'The MicroSD Card is write-protected. Please replace the MicroSD '
              'Card.',
    83902487: 'Binding failed. Please retry or restart the printer and retry.',
    83902488: 'Binding configuration information parsing failed, please try '
              'again.',
    83902489: 'The printer has already been bound. Please unbind it and try '
              'again.',
    83902490: 'Cloud access failed. Possible reasons include network '
              'instability caused by interference, inability to access the '
              'internet, or router firewall configuration restrictions. You '
              'can try moving the printer closer to the router or checking the '
              'router configuration and then try again.',
    83902491: 'Cloud response is invalid. If you have tried multiple times and '
              'are still failing, please contact customer service.',
    83902492: 'Cloud access is rejected. If you have tried multiple times and '
              'are still failing, please contact customer service.',
    83902493: 'Cloud access failed, which may be caused by network instability '
              'due to interference. You can try moving the printer closer to '
              'the router before you try again.',
    83902494: 'Cloud response is invalid. If you have tried multiple times and '
              'are still failing, please contact customer service.',
    83902495: 'Authorization timed out. Please make sure that your phone or PC '
              'has access to the internet, and ensure that the Bambu '
              'Studio/Bambu Handy APP is running in the foreground during the '
              'binding operation.',
    83902496: 'Cloud access rejected. If you have tried multiple times and are '
              'still failing, please contact customer service.',
    83902497: 'Cloud access failed, which may be caused by network instability '
              'due to interference. You can try moving the printer closer to '
              'the router before you try again.',
    83902498: 'Cloud response is invalid. If you have tried multiple times and '
              'are still failing, please contact customer service.',
    83902499: 'Cloud access rejected. If you have tried multiple times and are '
              'still failing, please contact customer service.',
    83902500: 'Cloud access failed. Possible reasons include network '
              'instability caused by interference, inability to access the '
              'internet, or router firewall configuration restrictions. You '
              'can try moving the printer closer to the router or checking the '
              'router configuration before you try again.',
    83902501: 'Cloud response is invalid. If you have tried multiple times and '
              'are still failing, please contact customer service.',
    83902502: 'Cloud access rejected. If you have tried multiple times and are '
              'still failing, please contact customer service.',
    83902503: 'Cloud access failed; this may be caused by network instability '
              'due to interference. You can try moving the printer closer to '
              'the router before you try again.',
    83902504: 'Cloud response is invalid. If you have tried multiple times and '
              'are still failing, please contact customer service.',
    83902505: 'Cloud access is rejected. If you have tried multiple times and '
              'are still failing, please contact customer service.',
    83902506: 'Failed to connect to the router, which may be caused by '
              'wireless interference or being too far away from the router. '
              'Please try again or move the printer closer to the router and '
              'try again.',
    83902507: 'Router connection failed due to incorrect password. Please '
              'check the password and try again.',
    83902508: 'Failed to obtain IP address, which may be caused by wireless '
              'interference resulting in data transmission failure or DHCP '
              'address pool of the router being full. Please move the printer '
              'closer to the router and try again. If the issue persists, '
              'please check router settings to see whether the IP addresses '
              'have been exhausted.',
    83902509: 'System exception.',
    83902510: 'The system does not support the file system currently used by '
              'the Micro SD card. Please replace the Micro SD card or format '
              'the current Micro SD card to FAT32.',
    83902511: 'The Micro SD card sector data is damaged. Please use the SD '
              'card repair tool to repair or format it. If it still cannot be '
              'identified, please replace the Micro SD card.',
    83902519: 'Your sliced file is not compatible with current printer model. '
              "This file can't be printed on this printer.",
    83902520: 'The nozzle diameter in sliced file is not consistent with the '
              "current nozzle setting. This file can't be printed.",
    83902522: 'The current temperature is too low. In order to protect you and '
              'your printer. Printing task, moving axis and other operations '
              'is disabled. Please move the printer to an environment above 10 '
              'celsius degree. ',
    83918867: 'The print file is not available. Please check to see if the '
              'storage media has been removed.',
    83918902: 'Your sliced file is not consistent with the current printer '
              'model. Continue?',
    83935248: 'MicroSD Card read/write exception. please reinsert or replace '
              'MicroSD Card .',
    83968023: 'Binding failed. Please retry or restart the printer and retry.',
    83968024: 'Binding configuration information parsing failed, please try '
              'again.',
    83968025: 'The printer has already been bound. Please unbind it and try '
              'again.',
    83968026: 'Cloud access failed. Possible reasons include network '
              'instability caused by interference, inability to access the '
              'internet, or router firewall configuration restrictions. You '
              'can try moving the printer closer to the router or checking the '
              'router configuration and then try again.',
    83968027: 'Cloud response is invalid. If you have tried multiple times and '
              'are still failing, please contact customer service.',
    83968028: 'Cloud access is rejected. If you have tried multiple times and '
              'are still failing, please contact customer service.',
    83968029: 'Cloud access failed, which may be caused by network instability '
              'due to interference. You can try moving the printer closer to '
              'the router before you try again.',
    83968030: 'Cloud response is invalid. If you have tried multiple times and '
              'are still failing, please contact customer service.',
    83968031: 'Authorization timed out. Please make sure that your phone or PC '
              'has access to the internet, and ensure that the Bambu '
              'Studio/Bambu Handy APP is running in the foreground during the '
              'binding operation.',
    83968032: 'Cloud access rejected. If you have tried multiple times and are '
              'still failing, please contact customer service.',
    83968033: 'Cloud access failed, which may be caused by network instability '
              'due to interference. You can try moving the printer closer to '
              'the router before you try again.',
    83968034: 'Cloud response is invalid. If you have tried multiple times and '
              'are still failing, please contact customer service.',
    83968035: 'Cloud access rejected. If you have tried multiple times and are '
              'still failing, please contact customer service.',
    83968036: 'Cloud access failed. Possible reasons include network '
              'instability caused by interference, inability to access the '
              'internet, or router firewall configuration restrictions. You '
              'can try moving the printer closer to the router or checking the '
              'router configuration before you try again.',
    83968037: 'Cloud response is invalid. If you have tried multiple times and '
              'are still failing, please contact customer service.',
    83968038: 'Cloud access rejected. If you have tried multiple times and are '
              'still failing, please contact customer service.',
    83968039: 'Cloud access failed; this may be caused by network instability '
              'due to interference. You can try moving the printer closer to '
              'the router before you try again.',
    83968040: 'Cloud response is invalid. If you have tried multiple times and '
              'are still failing, please contact customer service.',
    83968041: 'Cloud access is rejected. If you have tried multiple times and '
              'are still failing, please contact customer service.',
    83968049: 'Device discovery binding is in progress, and the QR code cannot '
              'be displayed on the screen. You can wait for the binding to '
              'finish or abort the device discovery binding process in the '
              'APP/Studio and retry scanning the QR code on the screen for '
              'binding.',
    83968050: 'QR code binding is in progress, so device discovery binding '
              'cannot be performed. You can scan the QR code on the screen for '
              'binding or exit the QR code display page on screen and try '
              'device discovery binding.',
    83968051: 'Your APP region is not matched with your printer, please '
              'download the APP in the corresponding region and register your '
              'account again.',
    83968052: 'The slicing progress has not been updated for a long time, and '
              'the printing task has exited. Please confirm the parameters and '
              'reinitiate printing.',
    83968053: 'The device is in the process of binding and cannot respond to '
              'new binding requests.',
    83968056: 'The regional settings do not match the printer, please check '
              "the printer's regional settings.",
    117456897: 'The AMS has been disabled for a print, but it still has '
               'filament loaded. Please unload the AMS filament , and switch '
               'to the spool holder filament for printing.',
    117473281: 'Failed to cut the filament. Please check the cutter. After '
               'troubleshooting, click the "Retry" button.',
    117473282: 'The cutter is stuck. Please make sure the cutter handle is '
               'out.',
    117473283: 'Failed to pull out the filament from the extruder. This might '
               'be caused by clogged extruder or filament broken inside the '
               'extruder. ',
    117473284: 'AMS failed to pull back filament. This could be due to a stuck '
               'spool or the end of the filament being stuck in the path.',
    117473285: 'The AMS failed to send out filament. You can clip the end of '
               'your filament flat, and reinsert. If this message persists, '
               'please check the PTFE tubes in AMS for any signs of wear and '
               'tear.',
    117473286: 'Unable to feed filament into the extruder. This could be due '
               'to entangled filament or a stuck spool. If not, please check '
               'if the AMS PTFE tube is connected.',
    117473287: 'Extruding filament failed. The extruder might be clogged. ',
    117473296: 'The AMS assist motor is overloaded. This could be due to '
               'entangled filament or a stuck spool.',
    117473297: 'AMS filament ran out. Please insert a new filament into the '
               'same AMS slot.',
    117473298: 'Failed to get AMS mapping table; please click "Retry" to '
               'continue.',
    117473299: 'Timeout purging old filament: Please check if the filament is '
               'stuck or the extruder is clogged. After troubleshooting, click '
               'the "Retry" button.',
    117522433: 'Filament is still loaded from the AMS after it has been '
               'disabled. Please unload the filament, load from the spool '
               'holder, and restart printing.',
    117538817: 'Failed to cut the filament. Please check the cutter. After '
               'troubleshooting, click the "Retry" button.',
    117538818: 'The cutter is stuck. Please pull out the cutter handle and '
               'click the "Retry" button.',
    117538819: 'Failed to pull out the filament from the extruder. There may '
               'be an extruder clog or broken filament inside the extruder. ',
    117538820: 'AMS failed to pull back filament. This could be due to a stuck '
               'spool or the end of the filament being stuck in the path.',
    117538821: 'The AMS failed to send filament. You canclip the end of your '
               'filament flat, and reinsert. If this message persists, please '
               'check the PTFE tubes in AMS for any signs of wear and tear.',
    117538822: 'Unable to feed filament into the extruder. This could be due '
               'to entangled filament or a stuck spool.',
    117538823: 'Failed to extrude the filament. Please check if the extruder '
               'clogged. After troubleshooting, click the "Retry" button.',
    117538832: 'The AMS assist motor is overloaded. This could be due to '
               'entangled filament or a stuck spool.',
    117538833: 'AMS filament ran out. Please insert a new filament into the '
               'same AMS slot.',
    117538834: 'Failed to get AMS mapping table; please click "Retry" to '
               'continue.',
    117538835: 'Timeout purging old filament: Please check if the filament is '
               'stuck or the extruder is clogged. After troubleshooting, click '
               'the "Retry" button.',
    117587969: 'Filament is still loaded from the AMS after it has been '
               'disabled. Please unload the filament, load from the spool '
               'holder, and restart printing.',
    117604353: 'Failed to cut the filament. Please check the cutter. After '
               'troubleshooting, click the "Retry" button.',
    117604354: 'The cutter is stuck. Please pull out the cutter handle and '
               'click the "Retry" button.',
    117604355: 'Failed to pull out the filament from the extruder. Please '
               'check whether the extruder is clogged or whether the filament '
               'is broken inside the extruder. After troubleshooting, click '
               'the "Retry" button.',
    117604356: 'Failed to pull back the filament from the toolhead to AMS. '
               'Please check whether the filament or the spool is stuck. After '
               'troubleshooting, click the "Retry" button.',
    117604357: 'Failed to feed the filament outside the AMS. Please clip the '
               'end of the filament flat and check to see if the spool is '
               'stuck. After troubleshooting, click the "Retry" button.',
    117604358: 'Failed to feed the filament into the toolhead. Please check '
               'whether the filament or the spool is stuck. After '
               'troubleshooting, click the "Retry" button.',
    117604359: 'Failed to extrude the filament. Please check if the extruder '
               'clogged. After troubleshooting, click the "Retry" button.',
    117604368: 'AMS assist motor is overloaded. Please check if the spool or '
               'filament is stuck. After troubleshooting, click the "Retry" '
               'button.',
    117604369: 'AMS filament ran out. Please insert a new filament into the '
               'same AMS slot.',
    117604370: 'Failed to get AMS mapping table; please click "Retry" to '
               'continue.',
    117604371: 'Timeout purging old filament: Please check if the filament is '
               'stuck or the extruder is clogged. After troubleshooting, click '
               'the "Retry" button.',
    117653505: 'Filament is still loaded from the AMS after it has been '
               'disabled. Please unload the filament, load from the spool '
               'holder, and restart printing.',
    117669889: 'Failed to cut the filament. Please check the cutter. After '
               'troubleshooting, click the "Retry" button.',
    117669890: 'The cutter is stuck. Please pull out the cutter handle and '
               'click the "Retry" button.',
    117669891: 'Failed to pull out the filament from the extruder. Please '
               'check whether the extruder is clogged or whether the filament '
               'is broken inside the extruder. After troubleshooting, click '
               'the "Retry" button.',
    117669892: 'Failed to pull back the filament from the toolhead to AMS. '
               'Please check whether the filament or the spool is stuck. After '
               'troubleshooting, click the "Retry" button.',
    117669893: 'Failed to feed the filament outside the AMS. Please clip the '
               'end of the filament flat and check to see if the spool is '
               'stuck. After troubleshooting, click the "Retry" button.',
    117669894: 'Failed to feed the filament into the toolhead. Please check '
               'whether the filament or the spool is stuck. After '
               'troubleshooting, click the "Retry" button.',
    117669895: 'Failed to extrude the filament. Please check if the extruder '
               'clogged. After troubleshooting, click the "Retry" button.',
    117669904: 'AMS assist motor is overloaded. Please check if the spool or '
               'filament is stuck. After troubleshooting, click the "Retry" '
               'button.',
    117669905: 'AMS filament ran out. Please insert a new filament into the '
               'same AMS slot.',
    117669906: 'Failed to get AMS mapping table; please click "Retry" to '
               'continue.',
    117669907: 'Timeout purging old filament: Please check if the filament is '
               'stuck or the extruder is clogged. After troubleshooting, click '
               'the "Retry" button.',
    134168577: 'Filament is still loaded from the AMS after it has been '
               'disabled. Please unload the filament, load from the spool '
               'holder, and restart printing.',
    134184961: 'Failed to cut the filament. Please check the cutter. After '
               'troubleshooting, click the "Retry" button.',
    134184962: 'The cutter is stuck. Please pull out the cutter handle and '
               'click the "Retry" button.',
    134184963: 'Please pull out the filament on the spool holder. If this '
               'message persists, please check to see if there is filament '
               'broken in the extruder. (Connect PTFE tube if you are about to '
               'use AMS)',
    134184964: 'Failed to pull back the filament from the toolhead to AMS. '
               'Please check whether the filament or the spool is stuck. After '
               'troubleshooting, click the "retry" button.',
    134184965: 'Failed to feed the filament outside the AMS. Please clip the '
               'end of the filament flat and check to see if the spool is '
               'stuck. After troubleshooting, click the "Retry" button.',
    134184966: 'Please feed filament into the PTFE tube until it can not be '
               'pushed any farther.',
    134184967: 'Please observe the nozzle. If the filament has been extruded, '
               'click "Done"; if it is not, please push the filament forward '
               'slightly and then click "Retry".',
    134184976: 'AMS assist motor is overloaded. Please check if the spool or '
               'filament is stuck. After troubleshooting, click the "Retry" '
               'button.',
    134184977: 'AMS filament ran out. Please put a new filament into AMS and '
               'click the "Retry" button.',
    134184978: 'Failed to get AMS mapping table; please click "Retry" to '
               'continue.',
    134184979: 'Timeout purging old filament: Please check if the filament is '
               'stuck or the extruder is clogged. After troubleshooting, click '
               'the "Retry" button.',
    134201347: 'Please pull out the filament on the spool holder. If this '
               'message persists, please check to see if there is filament '
               'broken in the extruder or PTFE Tube. (Connect PTFE tube if you '
               'are about to use AMS)',
    134201350: 'Please feed filament into the PTFE tube until it can not be '
               'pushed any farther.',
    201359361: 'First layer defects were detected. If the defects are '
               'acceptable, click "Resume" button to resume the print job.',
    201359362: 'Spaghetti failure was detected.',
    201359365: 'Purged filament has piled up in the waste chute, which may '
               'cause a tool head collision.',
    201359369: 'Build plate localization marker was not found.',
    201359370: 'The detected build plate is not the same as in G-code.',
    201375747: 'Possible defects were detected in the first layer.',
    201375748: 'Possible spaghetti failure was detected.',
    201375750: 'Purged filament may have piled up in the waste chute.',
    268484609: 'High bed temperature may lead to filament clogging in the '
               'nozzle. Please ensure ventilation for the printer.',
    268484610: 'Printing CF material with stainless steel may cause nozzle '
               'damage.',
    268484611: 'Enabling traditional timelapse might lead to defects. Please '
               'enable it as needed?',
    268550145: 'Timelapse is not supported because Spiral vase is enabled in '
               'slicing presets.',
    268550146: 'Timelapse is not supported because Print sequence is set to '
               '"By object".',
    302006273: 'Filament is still loaded from the AMS when it has been '
               'disabled. Please unload AMS filament, load from spool holder, '
               'and restart print job.',
    302022657: 'Cutting the filament failed. Please check to see if the cutter '
               'is stuck. Refer to the Assistant for solutions.',
    302022658: 'The cutter is stuck. Please pull out the cutter handle and '
               'click the "Retry" button.',
    302022659: 'Failed to pull out the filament from the extruder. Please '
               'check whether the extruder is clogged or whether the filament '
               'is broken inside the extruder. After troubleshooting, click '
               'the "Retry" button.',
    302022660: 'Failed to pull back the filament from the toolhead. Please '
               'check whether the filament is stuck. After troubleshooting, '
               'click the "Retry" button.',
    302022661: 'Failed to feed the filament. Please load the filament, then '
               'click the "Retry" button.',
    302022662: 'Failed to feed the filament into the toolhead. Please check '
               'whether the filament is stuck. After troubleshooting, click '
               'the "Retry" button.',
    302022663: 'Failed to extrude the filament. This might be caused by '
               'clogged extruder or stuck filament. Refer to the Assistant for '
               'solutions.',
    302022672: 'Filament or spool may be stuck. ',
    302022673: 'AMS filament ran out. Please insert a new filament into the '
               'same AMS slot.',
    302022674: 'Failed to get AMS mapping table. Please click the "Retry" '
               'button to continue.',
    302022675: 'Timeout while purging old filament. Please check if the '
               'filament is stuck or the extruder clogged. After '
               'troubleshooting, click the "Retry" button.',
    302022676: 'The filament location in the toolhead was not found. Refer to '
               'the Assistant for solutions.',
    302022677: 'Failed to pull out the filament from the toolhead. Please '
               'check if the filament is stuck, or the filament is broken '
               'inside the extruder or PTFE tube.',
    302022678: 'The extruder is not extruding normally, please refer to the '
               'HMS. After trouble shooting. If the defects are acceptable, '
               'please click "Retry" button.',
    302071809: 'Filament is still loaded from the AMS when it has been '
               'disabled. Please unload AMS filament, load from spool holder, '
               'and restart print job.',
    302088193: 'Failed to cut the filament. Please check the cutter. After '
               'troubleshooting, click the "Retry" button.',
    302088194: 'The cutter is stuck. Please pull out the cutter handle and '
               'click the "Retry" button.',
    302088195: 'Failed to pull out the filament from the extruder. Please '
               'check whether the extruder is clogged or whether the filament '
               'is broken inside the extruder. After troubleshooting, click '
               'the "Retry" button.',
    302088196: 'Failed to pull back the filament from the toolhead. Please '
               'check whether the filament is stuck. After troubleshooting, '
               'click the "Retry" button.',
    302088197: 'Failed to feed the filament. Please load the filament and then '
               'click the "Retry" button.',
    302088198: 'Failed to feed the filament into the toolhead. Please check '
               'whether the filament is stuck. After troubleshooting, click '
               'the "Retry" button.',
    302088199: 'Failed to extrude the filament. The extruder may be clogged or '
               'the filament may be stuck, please refer to HMS. After '
               'troubleshooting, click "Retry" button.',
    302088208: 'Please check if the spool or filament is stuck. After '
               'troubleshooting, click the "Retry" button.',
    302088209: 'AMS filament has run out. Please insert a new filament into '
               'the AMS and click the "Retry" button.',
    302088210: 'Failed to get AMS mapping table; please click the "Retry" '
               'button to continue.',
    302088211: 'Timeout while purging old filament. Please check if the '
               'filament is stuck or the extruder clogged. After '
               'troubleshooting, click the "Retry" button.',
    302088212: 'Failed to check the filament location in the tool head, please '
               'refer to the HMS. After troubleshooting, click the "Retry" '
               'button.',
    302088213: 'Failed to pull back the filament from the toolhead. Please '
               'check if the filament is stuck or the filament is broken '
               'inside the extruder. After troubleshooting, click the "Retry" '
               'button.',
    302088214: 'The extruder is not extruding normally, please refer to the '
               'HMS. After trouble shooting. If the defects are acceptable, '
               'please click "Retry" button.',
    302137345: 'Filament is still loaded from the AMS when it has been '
               'disabled. Please unload AMS filament, load from spool holder, '
               'and restart print job.',
    302153729: 'Failed to cut the filament. Please check the cutter. After '
               'troubleshooting, click the "Retry" button.',
    302153730: 'The cutter is stuck. Please pull out the cutter handle and '
               'click the "Retry" button.',
    302153731: 'Failed to pull out the filament from the extruder. Please '
               'check whether the extruder is clogged or whether the filament '
               'is broken inside the extruder. After troubleshooting, click '
               'the "Retry" button.',
    302153732: 'Failed to pull back the filament from the toolhead. Please '
               'check whether the filament is stuck. After troubleshooting, '
               'click the "Retry" button.',
    302153733: 'Failed to feed the filament. Please load the filament, then '
               'click the "Retry" button.',
    302153734: 'Failed to feed the filament into the toolhead. Please check '
               'whether the filament is stuck. After troubleshooting, click '
               'the "Retry" button.',
    302153735: 'Failed to extrude the filament. The extruder may be clogged or '
               'the filament may be stuck, please refer to HMS. After '
               'troubleshooting, click "Retry" button.',
    302153744: 'Please check if the spool or filament is stuck. After '
               'troubleshooting, click the "Retry" button.',
    302153745: 'AMS filament has run out. Please insert a new filament into '
               'the AMS and click the "Retry" button.',
    302153746: 'Failed to get AMS mapping table; please click the "Retry" '
               'button to continue.',
    302153747: 'Timeout while purging old filament. Please check if the '
               'filament is stuck or the extruder clogged. After '
               'troubleshooting, click the "Retry" button.',
    302153748: 'Failed to check the filament location in the tool head, please '
               'refer to the HMS. After troubleshooting, click the "Retry" '
               'button.',
    302153749: 'Failed to pull back the filament from the toolhead. Please '
               'check if the filament is stuck or is broken inside the '
               'extruder. After troubleshooting, click the "Retry" button.',
    302153750: 'The extruder is not extruding normally, please refer to the '
               'HMS. After trouble shooting. If the defects are acceptable, '
               'please click "Retry" button.',
    302202881: 'Filament is still loaded from the AMS when it has been '
               'disabled. Please unload AMS filament, load from spool holder, '
               'and restart print job.',
    302219265: 'Failed to cut the filament. Please check the cutter. After '
               'troubleshooting, click the "Retry" button.',
    302219266: 'The cutter is stuck. Please pull out the cutter handle and '
               'click the "Retry" button.',
    302219267: 'Failed to pull out the filament from the extruder. Please '
               'check whether the extruder is clogged or whether the filament '
               'is broken inside the extruder. After troubleshooting, click '
               'the "Retry" button.',
    302219268: 'Failed to pull back the filament from the toolhead. Please '
               'check whether the filament is stuck. After troubleshooting, '
               'click the "Retry" button.',
    302219269: 'Failed to feed the filament. Please load the filament, then '
               'click the "Retry" button.',
    302219270: 'Failed to feed the filament into the toolhead. Please check '
               'whether the filament is stuck. After troubleshooting, click '
               'the "Retry" button.',
    302219271: 'Failed to extrude the filament. The extruder may be clogged or '
               'the filament may be stuck, please refer to HMS. After '
               'troubleshooting, click "Retry" button.',
    302219280: 'Please check if the spool or filament is stuck. After '
               'troubleshooting, click the "Retry" button.',
    302219281: 'AMS filament has run out. Please insert a new filament into '
               'the AMS and click the "Retry" button.',
    302219282: 'Failed to get AMS mapping table; please click the "Retry" '
               'button to continue.',
    302219283: 'Timeout while purging old filament. Please check if the '
               'filament is stuck or the extruder clogged. After '
               'troubleshooting, click the "Retry" button.',
    302219284: 'Failed to check the filament location in the tool head; please '
               'refer to the HMS. After troubleshooting, click the "Retry" '
               'button.',
    302219285: 'Failed to pull back the filament from the toolhead. Please '
               'check if the filament is stuck or is broken inside the '
               'extruder. After troubleshooting, click the "Retry" button.',
    302219286: 'The extruder is not extruding normally, please refer to the '
               'HMS. After trouble shooting. If the defects are acceptable, '
               'please click "Retry" button.',
    318717953: 'Filament is still loaded from the AMS when it has been '
               'disabled. Please unload AMS filament, load from spool holder, '
               'and restart print job.',
    318734337: 'Failed to cut the filament. Please check the cutter. After '
               'troubleshooting, click the "Retry" button.',
    318734338: 'The cutter is stuck. Please pull out the cutter handle and '
               'click the "Retry" button.',
    318734339: 'Please pull out the filament on the spool holder. If this '
               'message persists, please check to see if there is filament '
               'broken in the extruder or PTFE Tube. (Connect PTFE tube if you '
               'are about to use AMS)',
    318734340: 'Failed to pull back the filament from the toolhead. Please '
               'check whether the filament is stuck. After troubleshooting, '
               'click the "Retry" button.',
    318734341: 'Failed to feed the filament. Please load the filament, then '
               'click the "Retry" button.',
    318734342: 'Please feed filament into the PTFE tube until it can not be '
               'pushed any farther.',
    318734343: 'Check nozzle. Click "Done" if filament was extruded, otherwise '
               'push filament forward slightly and click "Retry."',
    318734352: 'Please check if the filament or the spool is stuck.',
    318734353: 'AMS filament has run out. Please insert a new filament into '
               'the AMS and click the "Retry" button.',
    318734354: 'Failed to get AMS mapping table; please click the "Retry" '
               'button to continue.',
    318734355: 'Timeout while purging old filament. Please check if the '
               'filament is stuck or the extruder clogged. After '
               'troubleshooting, click the "Retry" button.',
    318750723: 'Please pull out the filament on the spool holder. If this '
               'message persists, please check to see if there is filament '
               'broken in the extruder or PTFE Tube. (Connect PTFE tube if you '
               'are about to use AMS)',
    318750726: 'Please feed filament into the PTFE tube until it can not be '
               'pushed any farther.'
}
